import java.io.*;
import evSOLve.JEvolution.*;

/** A test bed for the package evSOLve.JEvolution.
*
* @version 0.4
* @author Helmut A. Mayer
* @since November 8, 1999
*
*/


public class GATest {


/** To run JEvolution, you only need the following steps
*
* - create a JEvolution object
* - get the associated reporter
* - create the Chromosome(s) needed
* - pass the Chromosome(s) to JEvolution
* - pass your Phenotype class to JEvolution (see ParaboloidePhenotype.java)
*
* These necessary steps are indicated by `+` in the comments,
* the `-' lines are optional. Note that all parameters have default values
* which you can (and should) change easily. Some examples for setting
* parameters are included under comment characters.
* 
*/

	public static void main(String[] args) {
	
		
		JEvolution GA = new JEvolution();									//+ call it a GA			
		JEvolutionReporter GAStats = (JEvolutionReporter)GA.getJEvolutionReporter();	//- get the reporter
		BitChromosome chromX = new BitChromosome();							//+ create a chromosome
		
		try {
			chromX.setLength(12);											//- only set to justify try statement..;-)
//			chromX.setMutationRate(0.08);
//			chromX.setSoupType(Chromosome.LAPLACE);
//			chromX.setCrossoverPoints(2);
			BitChromosome chromY = (BitChromosome)chromX.clone();			//- second chromosome, demonstration purpose
			
			GA.addChromosome(chromX);										//+ tell GA about your chromosome		
			GA.addChromosome(chromY);										//- second one	
//			GA.setSelection(new TournamentSelection(4));					//- set selection method, default binary tournament	
			GA.setPhenotype(new ParaboloidePhenotype());					//+ tell GA about your Phenotype class
			
//			GAStats.setReportLevel(JEvolutionReporter.VERBOSE);
//			GAStats.useFitnessRepository(true);
		} catch (JEvolutionException e) {
			System.out.println(e.toString());
			System.out.println("Continuing with default values.");
		}
		GA.doEvolve();
	}

}

